﻿using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Input;

namespace ComboboxAdvSaveSample
{
    public class ViewModel : INotifyPropertyChanged
    {


        public ICommand SelectAllItemsCommand { get; set; }
        private ObservableCollection<object> _allItems;

     
       
        private ObservableCollection<object> _selectedItems;
        public ObservableCollection<object> SelectedItems
        {
            get { return _selectedItems; }
            set
            {
                if (_selectedItems == value) return;
                _selectedItems = value;
                RaisePropertyChanged("SelectedItems");
            }
        }

        private ObservableCollection<Model> products;

        public ObservableCollection<Model> Products
        {

            get { return products; }



            set { products = value; }

        }
        public ViewModel()
        {

            Products = new ObservableCollection<Model>();

            Products.Add(new Model() { Name = "Tools",IsChecked=true });
            Products.Add(new Model() { Name = "Grid ", IsChecked = true });

            Products.Add(new Model() { Name = "Maps", IsChecked = false });

            Products.Add(new Model() { Name = "Chart", IsChecked = false });

            Products.Add(new Model() { Name = "Diagram", IsChecked = false });
            Products.Add(new Model() { Name = "Consulting", IsChecked = false });
            Products.Add(new Model() { Name = "BigData", IsChecked = false });
            Products.Add(new Model() { Name = "Schedule", IsChecked = false });
            Products.Add(new Model() { Name = "Reports", IsChecked = false });
            Products.Add(new Model() { Name = "BI", IsChecked = false });

           
            _allItems = new ObservableCollection<object>();
           
            foreach(var item in Products)
            {
                if((item as Model).IsChecked==true)
                {
                    _allItems.Add(item);
                }
            }

            SelectAllItemsCommand = new DelegateCommand(SelectAllItems);
         
           

        }
        private void SelectAllItems(object obj)
        {
            SelectedItems = new ObservableCollection<object>(_allItems);
        }       

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            var pc = PropertyChanged;
            if (pc != null)
                pc(this, new PropertyChangedEventArgs(propertyName));
         

           
        }
    }
   
}
